"""
Type annotations for bedrock-agentcore-control service literal definitions.

[Documentation](https://youtype.github.io/types_boto3_docs/types_boto3_bedrock_agentcore_control/literals/)

Copyright 2025 Vlad Emelianov

Usage::

    ```python
    from types_boto3_bedrock_agentcore_control.literals import AgentEndpointStatusType

    data: AgentEndpointStatusType = "CREATE_FAILED"
    ```
"""

import sys

if sys.version_info >= (3, 12):
    from typing import Literal
else:
    from typing_extensions import Literal


__all__ = (
    "AgentEndpointStatusType",
    "AgentStatusType",
    "ApiKeyCredentialLocationType",
    "AuthorizerTypeType",
    "BedrockAgentCoreControlPlaneFrontingLayerServiceName",
    "BrowserNetworkModeType",
    "BrowserStatusType",
    "CodeInterpreterNetworkModeType",
    "CodeInterpreterStatusType",
    "CredentialProviderTypeType",
    "CredentialProviderVendorTypeType",
    "ExceptionLevelType",
    "GatewayProtocolTypeType",
    "GatewayStatusType",
    "KeyTypeType",
    "ListAgentRuntimeEndpointsPaginatorName",
    "ListAgentRuntimeVersionsPaginatorName",
    "ListAgentRuntimesPaginatorName",
    "ListApiKeyCredentialProvidersPaginatorName",
    "ListBrowsersPaginatorName",
    "ListCodeInterpretersPaginatorName",
    "ListGatewayTargetsPaginatorName",
    "ListGatewaysPaginatorName",
    "ListMemoriesPaginatorName",
    "ListOauth2CredentialProvidersPaginatorName",
    "ListWorkloadIdentitiesPaginatorName",
    "MemoryCreatedWaiterName",
    "MemoryStatusType",
    "MemoryStrategyStatusType",
    "MemoryStrategyTypeType",
    "NetworkModeType",
    "OverrideTypeType",
    "PaginatorName",
    "ResourceServiceName",
    "ResourceTypeType",
    "SchemaTypeType",
    "SearchTypeType",
    "ServerProtocolType",
    "ServiceName",
    "TargetStatusType",
    "WaiterName",
)


AgentEndpointStatusType = Literal[
    "CREATE_FAILED", "CREATING", "DELETING", "READY", "UPDATE_FAILED", "UPDATING"
]
AgentStatusType = Literal[
    "CREATE_FAILED", "CREATING", "DELETING", "READY", "UPDATE_FAILED", "UPDATING"
]
ApiKeyCredentialLocationType = Literal["HEADER", "QUERY_PARAMETER"]
AuthorizerTypeType = Literal["CUSTOM_JWT"]
BrowserNetworkModeType = Literal["PUBLIC"]
BrowserStatusType = Literal[
    "CREATE_FAILED", "CREATING", "DELETED", "DELETE_FAILED", "DELETING", "READY"
]
CodeInterpreterNetworkModeType = Literal["PUBLIC", "SANDBOX"]
CodeInterpreterStatusType = Literal[
    "CREATE_FAILED", "CREATING", "DELETED", "DELETE_FAILED", "DELETING", "READY"
]
CredentialProviderTypeType = Literal["API_KEY", "GATEWAY_IAM_ROLE", "OAUTH"]
CredentialProviderVendorTypeType = Literal[
    "CustomOauth2",
    "GithubOauth2",
    "GoogleOauth2",
    "MicrosoftOauth2",
    "SalesforceOauth2",
    "SlackOauth2",
]
ExceptionLevelType = Literal["DEBUG"]
GatewayProtocolTypeType = Literal["MCP"]
GatewayStatusType = Literal[
    "CREATING", "DELETING", "FAILED", "READY", "UPDATE_UNSUCCESSFUL", "UPDATING"
]
KeyTypeType = Literal["CustomerManagedKey", "ServiceManagedKey"]
ListAgentRuntimeEndpointsPaginatorName = Literal["list_agent_runtime_endpoints"]
ListAgentRuntimeVersionsPaginatorName = Literal["list_agent_runtime_versions"]
ListAgentRuntimesPaginatorName = Literal["list_agent_runtimes"]
ListApiKeyCredentialProvidersPaginatorName = Literal["list_api_key_credential_providers"]
ListBrowsersPaginatorName = Literal["list_browsers"]
ListCodeInterpretersPaginatorName = Literal["list_code_interpreters"]
ListGatewayTargetsPaginatorName = Literal["list_gateway_targets"]
ListGatewaysPaginatorName = Literal["list_gateways"]
ListMemoriesPaginatorName = Literal["list_memories"]
ListOauth2CredentialProvidersPaginatorName = Literal["list_oauth2_credential_providers"]
ListWorkloadIdentitiesPaginatorName = Literal["list_workload_identities"]
MemoryCreatedWaiterName = Literal["memory_created"]
MemoryStatusType = Literal["ACTIVE", "CREATING", "DELETING", "FAILED"]
MemoryStrategyStatusType = Literal["ACTIVE", "CREATING", "DELETING", "FAILED"]
MemoryStrategyTypeType = Literal["CUSTOM", "SEMANTIC", "SUMMARIZATION", "USER_PREFERENCE"]
NetworkModeType = Literal["PUBLIC"]
OverrideTypeType = Literal["SEMANTIC_OVERRIDE", "SUMMARY_OVERRIDE", "USER_PREFERENCE_OVERRIDE"]
ResourceTypeType = Literal["CUSTOM", "SYSTEM"]
SchemaTypeType = Literal["array", "boolean", "integer", "number", "object", "string"]
SearchTypeType = Literal["SEMANTIC"]
ServerProtocolType = Literal["HTTP", "MCP"]
TargetStatusType = Literal[
    "CREATING", "DELETING", "FAILED", "READY", "UPDATE_UNSUCCESSFUL", "UPDATING"
]
BedrockAgentCoreControlPlaneFrontingLayerServiceName = Literal["bedrock-agentcore-control"]
ServiceName = Literal[
    "accessanalyzer",
    "account",
    "acm",
    "acm-pca",
    "aiops",
    "amp",
    "amplify",
    "amplifybackend",
    "amplifyuibuilder",
    "apigateway",
    "apigatewaymanagementapi",
    "apigatewayv2",
    "appconfig",
    "appconfigdata",
    "appfabric",
    "appflow",
    "appintegrations",
    "application-autoscaling",
    "application-insights",
    "application-signals",
    "applicationcostprofiler",
    "appmesh",
    "apprunner",
    "appstream",
    "appsync",
    "apptest",
    "arc-zonal-shift",
    "artifact",
    "athena",
    "auditmanager",
    "autoscaling",
    "autoscaling-plans",
    "b2bi",
    "backup",
    "backup-gateway",
    "backupsearch",
    "batch",
    "bcm-data-exports",
    "bcm-pricing-calculator",
    "bedrock",
    "bedrock-agent",
    "bedrock-agent-runtime",
    "bedrock-agentcore",
    "bedrock-agentcore-control",
    "bedrock-data-automation",
    "bedrock-data-automation-runtime",
    "bedrock-runtime",
    "billing",
    "billingconductor",
    "braket",
    "budgets",
    "ce",
    "chatbot",
    "chime",
    "chime-sdk-identity",
    "chime-sdk-media-pipelines",
    "chime-sdk-meetings",
    "chime-sdk-messaging",
    "chime-sdk-voice",
    "cleanrooms",
    "cleanroomsml",
    "cloud9",
    "cloudcontrol",
    "clouddirectory",
    "cloudformation",
    "cloudfront",
    "cloudfront-keyvaluestore",
    "cloudhsm",
    "cloudhsmv2",
    "cloudsearch",
    "cloudsearchdomain",
    "cloudtrail",
    "cloudtrail-data",
    "cloudwatch",
    "codeartifact",
    "codebuild",
    "codecatalyst",
    "codecommit",
    "codeconnections",
    "codedeploy",
    "codeguru-reviewer",
    "codeguru-security",
    "codeguruprofiler",
    "codepipeline",
    "codestar-connections",
    "codestar-notifications",
    "cognito-identity",
    "cognito-idp",
    "cognito-sync",
    "comprehend",
    "comprehendmedical",
    "compute-optimizer",
    "config",
    "connect",
    "connect-contact-lens",
    "connectcampaigns",
    "connectcampaignsv2",
    "connectcases",
    "connectparticipant",
    "controlcatalog",
    "controltower",
    "cost-optimization-hub",
    "cur",
    "customer-profiles",
    "databrew",
    "dataexchange",
    "datapipeline",
    "datasync",
    "datazone",
    "dax",
    "deadline",
    "detective",
    "devicefarm",
    "devops-guru",
    "directconnect",
    "discovery",
    "dlm",
    "dms",
    "docdb",
    "docdb-elastic",
    "drs",
    "ds",
    "ds-data",
    "dsql",
    "dynamodb",
    "dynamodbstreams",
    "ebs",
    "ec2",
    "ec2-instance-connect",
    "ecr",
    "ecr-public",
    "ecs",
    "efs",
    "eks",
    "eks-auth",
    "elasticache",
    "elasticbeanstalk",
    "elastictranscoder",
    "elb",
    "elbv2",
    "emr",
    "emr-containers",
    "emr-serverless",
    "entityresolution",
    "es",
    "events",
    "evidently",
    "evs",
    "finspace",
    "finspace-data",
    "firehose",
    "fis",
    "fms",
    "forecast",
    "forecastquery",
    "frauddetector",
    "freetier",
    "fsx",
    "gamelift",
    "gameliftstreams",
    "geo-maps",
    "geo-places",
    "geo-routes",
    "glacier",
    "globalaccelerator",
    "glue",
    "grafana",
    "greengrass",
    "greengrassv2",
    "groundstation",
    "guardduty",
    "health",
    "healthlake",
    "iam",
    "identitystore",
    "imagebuilder",
    "importexport",
    "inspector",
    "inspector-scan",
    "inspector2",
    "internetmonitor",
    "invoicing",
    "iot",
    "iot-data",
    "iot-jobs-data",
    "iot-managed-integrations",
    "iotanalytics",
    "iotdeviceadvisor",
    "iotevents",
    "iotevents-data",
    "iotfleethub",
    "iotfleetwise",
    "iotsecuretunneling",
    "iotsitewise",
    "iotthingsgraph",
    "iottwinmaker",
    "iotwireless",
    "ivs",
    "ivs-realtime",
    "ivschat",
    "kafka",
    "kafkaconnect",
    "kendra",
    "kendra-ranking",
    "keyspaces",
    "keyspacesstreams",
    "kinesis",
    "kinesis-video-archived-media",
    "kinesis-video-media",
    "kinesis-video-signaling",
    "kinesis-video-webrtc-storage",
    "kinesisanalytics",
    "kinesisanalyticsv2",
    "kinesisvideo",
    "kms",
    "lakeformation",
    "lambda",
    "launch-wizard",
    "lex-models",
    "lex-runtime",
    "lexv2-models",
    "lexv2-runtime",
    "license-manager",
    "license-manager-linux-subscriptions",
    "license-manager-user-subscriptions",
    "lightsail",
    "location",
    "logs",
    "lookoutequipment",
    "lookoutmetrics",
    "lookoutvision",
    "m2",
    "machinelearning",
    "macie2",
    "mailmanager",
    "managedblockchain",
    "managedblockchain-query",
    "marketplace-agreement",
    "marketplace-catalog",
    "marketplace-deployment",
    "marketplace-entitlement",
    "marketplace-reporting",
    "marketplacecommerceanalytics",
    "mediaconnect",
    "mediaconvert",
    "medialive",
    "mediapackage",
    "mediapackage-vod",
    "mediapackagev2",
    "mediastore",
    "mediastore-data",
    "mediatailor",
    "medical-imaging",
    "memorydb",
    "meteringmarketplace",
    "mgh",
    "mgn",
    "migration-hub-refactor-spaces",
    "migrationhub-config",
    "migrationhuborchestrator",
    "migrationhubstrategy",
    "mpa",
    "mq",
    "mturk",
    "mwaa",
    "neptune",
    "neptune-graph",
    "neptunedata",
    "network-firewall",
    "networkflowmonitor",
    "networkmanager",
    "networkmonitor",
    "notifications",
    "notificationscontacts",
    "oam",
    "observabilityadmin",
    "odb",
    "omics",
    "opensearch",
    "opensearchserverless",
    "opsworks",
    "opsworkscm",
    "organizations",
    "osis",
    "outposts",
    "panorama",
    "partnercentral-selling",
    "payment-cryptography",
    "payment-cryptography-data",
    "pca-connector-ad",
    "pca-connector-scep",
    "pcs",
    "personalize",
    "personalize-events",
    "personalize-runtime",
    "pi",
    "pinpoint",
    "pinpoint-email",
    "pinpoint-sms-voice",
    "pinpoint-sms-voice-v2",
    "pipes",
    "polly",
    "pricing",
    "proton",
    "qapps",
    "qbusiness",
    "qconnect",
    "qldb",
    "qldb-session",
    "quicksight",
    "ram",
    "rbin",
    "rds",
    "rds-data",
    "redshift",
    "redshift-data",
    "redshift-serverless",
    "rekognition",
    "repostspace",
    "resiliencehub",
    "resource-explorer-2",
    "resource-groups",
    "resourcegroupstaggingapi",
    "robomaker",
    "rolesanywhere",
    "route53",
    "route53-recovery-cluster",
    "route53-recovery-control-config",
    "route53-recovery-readiness",
    "route53domains",
    "route53profiles",
    "route53resolver",
    "rum",
    "s3",
    "s3control",
    "s3outposts",
    "s3tables",
    "s3vectors",
    "sagemaker",
    "sagemaker-a2i-runtime",
    "sagemaker-edge",
    "sagemaker-featurestore-runtime",
    "sagemaker-geospatial",
    "sagemaker-metrics",
    "sagemaker-runtime",
    "savingsplans",
    "scheduler",
    "schemas",
    "sdb",
    "secretsmanager",
    "security-ir",
    "securityhub",
    "securitylake",
    "serverlessrepo",
    "service-quotas",
    "servicecatalog",
    "servicecatalog-appregistry",
    "servicediscovery",
    "ses",
    "sesv2",
    "shield",
    "signer",
    "simspaceweaver",
    "sms",
    "snow-device-management",
    "snowball",
    "sns",
    "socialmessaging",
    "sqs",
    "ssm",
    "ssm-contacts",
    "ssm-guiconnect",
    "ssm-incidents",
    "ssm-quicksetup",
    "ssm-sap",
    "sso",
    "sso-admin",
    "sso-oidc",
    "stepfunctions",
    "storagegateway",
    "sts",
    "supplychain",
    "support",
    "support-app",
    "swf",
    "synthetics",
    "taxsettings",
    "textract",
    "timestream-influxdb",
    "timestream-query",
    "timestream-write",
    "tnb",
    "transcribe",
    "transfer",
    "translate",
    "trustedadvisor",
    "verifiedpermissions",
    "voice-id",
    "vpc-lattice",
    "waf",
    "waf-regional",
    "wafv2",
    "wellarchitected",
    "wisdom",
    "workdocs",
    "workmail",
    "workmailmessageflow",
    "workspaces",
    "workspaces-instances",
    "workspaces-thin-client",
    "workspaces-web",
    "xray",
]
ResourceServiceName = Literal[
    "cloudformation",
    "cloudwatch",
    "dynamodb",
    "ec2",
    "glacier",
    "iam",
    "opsworks",
    "s3",
    "sns",
    "sqs",
]
PaginatorName = Literal[
    "list_agent_runtime_endpoints",
    "list_agent_runtime_versions",
    "list_agent_runtimes",
    "list_api_key_credential_providers",
    "list_browsers",
    "list_code_interpreters",
    "list_gateway_targets",
    "list_gateways",
    "list_memories",
    "list_oauth2_credential_providers",
    "list_workload_identities",
]
WaiterName = Literal["memory_created"]
